CPPFLAGS += -O2 -I../include -Wall -Wpedantic -Werror=strict-aliasing
CFLAGS += $(CPPFLAGS) -std=c99
CXXFLAGS += $(CPPFLAGS) -std=c++11

HEADERS = ../include/vec/vec.h \
	../include/vec/impl/ppc/altivec.h \
	../include/vec/impl/x86/avx2.h \
	../include/vec/impl/x86/avx512f.h \
	../include/vec/impl/x86/mmx.h \
	../include/vec/impl/x86/sse2.h \
	../include/vec/impl/x86/sse41.h \
	../include/vec/impl/cpu.h \
	../include/vec/impl/generic.h \
	test_align.h \
	test_arith.h \
	test_compare.h \
	test_shift.h \
	test_benchmark.h
BINS = test-generic test-host test-cxx
OBJS = test.o test-cxx.o test_benchmark_simple.o test_benchmark_vec.o

.PHONY: all clean test

all: $(BINS)

test.o: test.c test_benchmark_simple.o test_benchmark_vec.o $(HEADERS)
	$(CC) $(CFLAGS) -c -o $@ $<

test-cxx.o: test.cc
	$(CXX) $(CXXFLAGS) -c -o $@ $<

test-generic: test.o test_benchmark_simple.o test_benchmark_vec.o
	$(CC) $(LDFLAGS) -o $@ $^

test-host: test.o test_benchmark_simple.o test_benchmark_vec.o
	$(CC) $(LDFLAGS) -o $@ $^

test-cxx: test-cxx.o $(HEADERS)
	$(CXX) $(LDFLAGS) -o $@ $<

clean:
	$(RM) $(BINS) $(OBJS)

test: clean $(BINS)
	./test-generic
	./test-host
	./test-cxx
